function pixels = oms_convert_degrees2px(degrees,ScreenInfo)
% Converts degrees into pixels
% Version 1.2 - 2011-2021 by Matt J Dunn
% NOTE: On a flat screen, the relationship between degrees and pixels is non-linear. This conversion assumes you are measuring out from screen centre. 
% TODO: In a future version, allow for a non-central start point by including an extra optional input argument

millimetres = ScreenInfo.distance_mm * tand(degrees); % to convert from degrees to size of area on screen, use trigonometry
sizeOfOnePixel = ScreenInfo.width_mm / ScreenInfo.width_px; % this gives the size of one pixel in mm
pixels = millimetres / sizeOfOnePixel; % finally, multiply mm by px/mm to get px
