function degrees = oms_convert_px2degrees(pixels,ScreenInfo)
% Converts pixels into degrees
% Version 1.2 - 2011-2021 by Matt J Dunn
% NOTE: On a flat screen, the relationship between degrees and pixels is non-linear. This conversion assumes you are measuring out from screen centre. 
% TODO: In a future version, allow for a non-central start point by including an extra optional input argument

sizeOfOnePixel_mm = ScreenInfo.width_mm / ScreenInfo.width_px;
millimetres = pixels * sizeOfOnePixel_mm;
degrees = atand(millimetres / ScreenInfo.distance_mm);
