function [manualOffset_px,tempEyeTraceFileName,window] = oms_eyetracker_driftcorrection(tracker,type,window,~,~,~,tempEyeTraceFileName)

global EYETRACKERHANDLE

manualOffset_px = [0,0]; % init

if ~exist('tracker','var') || isempty(tracker)
    tracker = oms_eyetracker_getconnectedtracker;
end
if ~exist('type','var') || isempty(type)
    type = 'tracker_default';
end

switch type
    case 'none'
        % pass
    case 'tracker_default'
        oms_eyetracker_stoprecording(tracker); % stop recording
        switch tracker
            case 'eyelink'
                EyelinkDoDriftCorrection(EYETRACKERHANDLE); % perform drift correction
                Eyelink('command','set_idle_mode'); % set EL1000 idle, ready for next trial
                WaitSecs('YieldSecs',0.05); % wait a moment to let the EL1000 catch up
        end
        oms_eyetracker_startrecording(tracker); % start recording
end
