function tracker = oms_eyetracker_getavailabletracker
% Find which tracker is available to connect to (this function should be used before connecting to a tracker)

try
    disp('Looking for EyeLink eyetrackers...')
    if Eyelink('Initialize') == 0 % check if we can get the EyeLink initialised (not in dummy mode)
        tracker = 'eyelink';
    else
        tracker = 'none';
    end
catch % if the mex file is invalid, the catch block will be triggered
    tracker = 'none';
end

if strcmp(tracker,'none')
    warning('Unable to find any connected eye tracker')
end
