function [gazePosition_px,pupil,gazePosition_deg,newSampleAvailable,timestamp_ms,distance_mm] = oms_eyetracker_getgazedata_latestsample(eye,tracker,ScreenInfo)
% Simple function to get current gaze position from specified eye

if ~exist('tracker','var') || isempty(tracker)
    tracker = oms_eyetracker_getconnectedtracker;
end
if ~exist('eye','var') || isempty(eye) || strcmp(eye,'both')
    % TODO: Actually, this should default to the right eye ONLY if there is a binocular recording taking place. Fix this by checking first.
    eye = 'right'; % default to right eye
end

[newSampleAvailable,re_xPosition_px,re_yPosition_px,le_xPosition_px,le_yPosition_px,re_pupil,le_pupil,re_distance_mm,le_distance_mm,timestamp_ms] = oms_eyetracker_poll(tracker,ScreenInfo);
% Throw away all but last sample:
re_xPosition_px = re_xPosition_px(end);
re_yPosition_px = re_yPosition_px(end);
le_xPosition_px = le_xPosition_px(end);
le_yPosition_px = le_yPosition_px(end);
re_pupil = re_pupil(end);
le_pupil = le_pupil(end);
re_distance_mm = re_distance_mm(end);
le_distance_mm = le_distance_mm(end);

re_position_deg(1) = oms_convert_px2degrees(re_xPosition_px - ScreenInfo.width_px/2,ScreenInfo); % get gaze position relative to screen centre
re_position_deg(2) = oms_convert_px2degrees(-(re_yPosition_px - ScreenInfo.height_px/2),ScreenInfo); % get gaze position relative to screen centre
le_position_deg(1) = oms_convert_px2degrees(le_xPosition_px - ScreenInfo.width_px/2,ScreenInfo); % get gaze position relative to screen centre
le_position_deg(2) = oms_convert_px2degrees(-(le_yPosition_px - ScreenInfo.height_px/2),ScreenInfo); % get gaze position relative to screen centre

switch eye
    case 'right'
        gazePosition_px = [re_xPosition_px,re_yPosition_px];
        gazePosition_deg = re_position_deg;
        pupil = re_pupil;
        distance_mm = re_distance_mm;
    case 'left'
        gazePosition_px = [le_xPosition_px,le_yPosition_px];
        gazePosition_deg = le_position_deg;
        pupil = le_pupil;
        distance_mm = le_distance_mm;
end
