function oms_eyetracker_sendmessage(message,type,tracker,suppressConsoleOutput)
% Function to stamp a message in the stream of any eye tracker

if ~exist('type','var') || isempty(type)
    type = 'stamp'; % type can be 'stamp', 'status' or 'command'. 'stamp' stamps the message in the eyetrace; 'status' shows it on the Host PC; 'command' requests tracker-specific functions (for EyeLink)
end
if ~exist('tracker','var') || isempty(tracker)
    tracker = oms_eyetracker_getconnectedtracker;
end
if ~exist('suppressConsoleOutput','var') || isempty(suppressConsoleOutput)
    suppressConsoleOutput = false; % If set to true, the message won't also be printed to the MATLAB console
end

switch tracker
    case 'eyelink'
        switch type
            case 'stamp'
                Eyelink('Message',message);
            case 'status'
                Eyelink('command',['record_status_message "',message,'"']);
            case 'command'
                Eyelink('command',message);
        end
end

if ~suppressConsoleOutput
    disp(message)
end
