function oms_screen_shutdown(ScreenInfo,window,includeWaitScreen)

KbReleaseWait;

if ~exist('includeWaitScreen','var') || isempty(includeWaitScreen)
    includeWaitScreen = false; % if set to true, show a screen with prompt to press a key to continue (prevents sudden appearance of MATLAB console)
end

if includeWaitScreen
    textColour_rgb = 1 - ScreenInfo.backgroundColour_rgb;
    if all(textColour_rgb == 0.5) % if the screen is mid-grey
        textColour_rgb = 0; % make text black
    end
    DrawFormattedText(window,'Press ''q'' to end','center','center',textColour_rgb);
    Screen('Flip',window);
    oms_awaitkeypress([],[],'q');
end

ListenChar(0); % restore keyboard output to MATLAB
ShowCursor;
Screen('LoadNormalizedGammaTable',max(Screen('Screens')),linspace(0,1,256)'*[1,1,1]); % reset gamma

RestoreCluts; % load old gamma tables into graphics card

Priority(0);

BitsPlusPlus('Close');
Screen('CloseAll');

if exist('ScreenInfo','var') && ~isequal(Screen('Resolution',ScreenInfo.portId),ScreenInfo.oldResolution) % if ScreenInfo is supplied, and the current resolution is different the info contained in ScreenInfo.oldResolution
    SetResolution(ScreenInfo.portId,ScreenInfo.oldResolution); % return to the oldResolution
end
