function StaircaseObject = oms_staircase_init(nUp,nDown,nReversalsRequired,initialStimulusIntensity,stimulusStepSize,stimulusStepType)
% Initialise a psychophysical staircase object
% 2017-2021 by Matt J Dunn

if ~exist('stimulusStepType','var') || isempty(stimulusStepType)
    stimulusStepType = 'fixed'; % 'fixed' step or 'percentage' step. Default to fixed
end

StaircaseObject.nCorrect = 0; % initialise a variable to store number of consecutive correct reponses
StaircaseObject.nReversals = 0; % this will count our number of reversals
StaircaseObject.direction = 0; % direction begins at a nonsense value
StaircaseObject.iteration = 0;
StaircaseObject.GFIndex = 0;
StaircaseObject.firstPresentation = true;
StaircaseObject.nCorrect = 0;
StaircaseObject.nIncorrect = 0;
StaircaseObject.nUp = nUp;
StaircaseObject.nDown = nDown;
StaircaseObject.nReversalsRequired = nReversalsRequired;
StaircaseObject.reversals = nan(1,nReversalsRequired);
StaircaseObject.stop = false;
StaircaseObject.stimulusIntensity = initialStimulusIntensity;
StaircaseObject.stimulusStepSize = stimulusStepSize;
StaircaseObject.stimulusStepType = stimulusStepType;
