function [StimulusList_main,reactionTimeRecord_sec,escapePressed,tempEyeTraceFile,window] = wave(waveName,numberofStimulusPresentationsbetweenDriftCorrections,tracker,window,ScreenInfo,eye,startTimestamp,stimulusDuration_ms,CentralFixationTarget,backgroundLuminance_AU,gazeContingencyType,FixationReminderAnnulus,~,driftCorrectionOffset_deg,manualFixationOffset_deg,StimulusList_main,StaircaseParameters,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,falsePositiveCatchTime_sec,dynamicIntervalRange_min_max_sec,additionToInterstimulusInterval_sec,questTerminationMaximumIntervalSize,calibrationType,tempEyeTraceFile,startingIntensityAboveNormativeData_logarithmic,nReversalsRequired,maximumLuminance_cdm2,falsePOSfalseNEG_logIncrement)
pausePressed = false; % init
nPresentationsThisWave = 0; % init

if CentralFixationTarget.on
    oms_drawfixation(window,ScreenInfo,CentralFixationTarget.size_deg,[0,0],CentralFixationTarget.colour,true,true,CentralFixationTarget.type,backgroundLuminance_AU); % prepare central fixation target
end
Screen('Flip',window);
WaitSecs(1); % brief pause before each wave

presentationListForThisWave = 1:length(StimulusList_main); % init
thisWaveComplete = false; % init
while ~thisWaveComplete
    if nPresentationsThisWave > 0 && mod(nPresentationsThisWave,numberofStimulusPresentationsbetweenDriftCorrections) == 0 % is it time to perform a drift correction?
        [driftCorrectionOffset_px,tempEyeTraceFile,window] = oms_eyetracker_driftcorrection(tracker,calibrationType,window,ScreenInfo,eye,backgroundLuminance_AU,tempEyeTraceFile);
        driftCorrectionOffset_deg = oms_convert_px2degrees(driftCorrectionOffset_px,ScreenInfo); % convert to degrees
        WaitSecs(1); % brief pause after drift correction % TODO: if the fixation dot is turned on, it should be shown here
    end
    
    nPresentationsThisWave = nPresentationsThisWave + 1; % NOTE: This number doesn't keep track of repeated trials
    repeatTrial = true; % init as true
    if ~isempty(presentationListForThisWave)
        if length(presentationListForThisWave) > 1
            stimulusIndex = randsample(presentationListForThisWave,1);
        else
            stimulusIndex = presentationListForThisWave; % as there is only one presentation left, choose this one
        end
        
        if strcmp(waveName,'second') && StimulusList_main(stimulusIndex).falsePositivePresentationDue % false positive presentation
            while repeatTrial
                [escapePressed,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,StimulusList_main,pausePressed,~,repeatTrial] = presentation('false positive',StimulusList_main,nPresentationsThisWave,window,ScreenInfo,stimulusDuration_ms,CentralFixationTarget,backgroundLuminance_AU,eye,gazeContingencyType,FixationReminderAnnulus,[],tracker,driftCorrectionOffset_deg,manualFixationOffset_deg,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,stimulusIndex,startTimestamp,falsePositiveCatchTime_sec,dynamicIntervalRange_min_max_sec,pausePressed,additionToInterstimulusInterval_sec,startingIntensityAboveNormativeData_logarithmic,falsePOSfalseNEG_logIncrement,maximumLuminance_cdm2);
                if repeatTrial % if we have to repeat the trial...
                    stimulusIndex = randsample(presentationListForThisWave,1); % draw another stimulus index to use before we loop back up
                end
            end
            StimulusList_main(stimulusIndex).falsePositivePresentationDue = false; % remove the flag indicating a false positive presentation is due at this stmulus location
        elseif strcmp(waveName,'second') && StimulusList_main(stimulusIndex).falseNegativePresentationDue % false negative presentation
            while repeatTrial
                [escapePressed,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,StimulusList_main,pausePressed,~,repeatTrial] = presentation('false negative',StimulusList_main,nPresentationsThisWave,window,ScreenInfo,stimulusDuration_ms,CentralFixationTarget,backgroundLuminance_AU,eye,gazeContingencyType,FixationReminderAnnulus,[],tracker,driftCorrectionOffset_deg,manualFixationOffset_deg,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,stimulusIndex,startTimestamp,falsePositiveCatchTime_sec,dynamicIntervalRange_min_max_sec,pausePressed,additionToInterstimulusInterval_sec,startingIntensityAboveNormativeData_logarithmic,falsePOSfalseNEG_logIncrement,maximumLuminance_cdm2);
                if repeatTrial % if we have to repeat the trial...
                    stimulusIndex = randsample(presentationListForThisWave,1); % draw another stimulus index to use before we loop back up
                end
            end
            StimulusList_main(stimulusIndex).falseNegativePresentationDue = false; % remove the flag indicating a false negative presentation is due at this stmulus location
        elseif strcmp(waveName,'second') && StaircaseParameters.useStaircasesIfQuestFails && ismember(stimulusIndex,find([StimulusList_main.presentAsStaircase])) % if QUEST has failed at this location, we will switch to a staircase presentation
            % Initiate staircase:
            StimulusList_main(stimulusIndex).StaircaseObject.nReversals = 0;
            logIncrementMagnitude = 4; % our increments will be 4dB
            if StimulusList_main(stimulusIndex).StaircaseObject.nReversals == 0 && StimulusList_main(stimulusIndex).nPresentations == 1 && ~isnan(StimulusList_main(stimulusIndex).seen([StimulusList_main(stimulusIndex).nPresentations])) % if this is the first presentation of the staircase. The below if loop is for initial setting of luminance steps for staircase and to keep changing stimulus luminance by these steps until a reversal is made
                StimulusList_main(stimulusIndex).StaircaseObject = oms_staircase_init;
                if StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).seen % if previous QUEST threshold was seen
                    StimulusList_main(stimulusIndex).StaircaseObject.direction = -1; % define the staircase direction
                else % if previous QUEST threshold was not seen
                    StimulusList_main(stimulusIndex).StaircaseObject.direction = +1; % define the staircase direction
                end
                StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity = calculatenextstaircaseintensity(StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity(end-1),ScreenInfo,maximumLuminance_cdm2,StimulusList_main,logIncrementMagnitude); % calculate the next stimulus intensity required in the staircase based on logarithmic step sizes
            end
            while repeatTrial
                [escapePressed,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,StimulusList_main,pausePressed,stimulusActuallyPresented,repeatTrial] = presentation('staircase',StimulusList_main,nPresentationsThisWave,window,ScreenInfo,stimulusDuration_ms,CentralFixationTarget,backgroundLuminance_AU,eye,gazeContingencyType,FixationReminderAnnulus,[],tracker,driftCorrectionOffset_deg,manualFixationOffset_deg,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,stimulusIndex,startTimestamp,falsePositiveCatchTime_sec,dynamicIntervalRange_min_max_sec,pausePressed,additionToInterstimulusInterval_sec,startingIntensityAboveNormativeData_logarithmic,falsePOSfalseNEG_logIncrement,maximumLuminance_cdm2); % present stimulus
                if repeatTrial % if we have to repeat the trial...
                    stimulusIndex = randsample(presentationListForThisWave,1); % draw another stimulus index to use before we loop back up
                end
            end
            % Keep changing staircase by required logarithmic steps:
            if StimulusList_main(stimulusIndex).StaircaseObject.nReversals < 1 % keep changing the stimulus luminance by same amount until we get our first reversal and if previous trial is legitimate (i.e. target actually shown)
                if StimulusList_main(stimulusIndex).Presentations(end - 1).seen % if previous stimulus luminance was seen...
                    StimulusList_main(stimulusIndex).StaircaseObject.direction = -1;
                else % if previous stimulus luminance was not seen...
                    StimulusList_main(stimulusIndex).StaircaseObject.direction = +1;
                end
                StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity = calculatenextstaircaseintensity(StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity(end-1),ScreenInfo,maximumLuminance_cdm2,StimulusList_main,logIncrementMagnitude); % calculate the next stimulus intensity required in the staircase based on logarithmic step sizes
            end
            
            % Update staircase:
            if stimulusActuallyPresented && ~participantRespondedTooQuickly && ~isnan(StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).seen)
                correct = StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).seen; % was this stimulus seen?
                
                [StimulusList_main(stimulusIndex).StaircaseObject,nextStep,reversal] = oms_staircase_update(StimulusList_main(stimulusIndex).StaircaseObject,correct,nUp,nDown);
                
                if reversal
                    logIncrementMagnitude = 2; % turn off four logarithmic step increments and switch to two logarithmic steps
                    StimulusList_main(stimulusIndex).StaircaseObject.nReversals = StimulusList_main(stimulusIndex).StaircaseObject.nReversals + 1;
                    switch nextStep % nextStep is the command from oms_staircase_update to move up or down based on participant response
                        case +1 % if reversal to make stimulus brighter
                            StimulusList_main(stimulusIndex).StaircaseObject.direction = -1; % reverse direction of staircase
                        case -1 % if reversal to make stimulus dimmer
                            StimulusList_main(stimulusIndex).StaircaseObject.direction = +1; % reverse direction of staircase
                    end
                    StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity = calculatenextstaircaseintensity(StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity(end-1),ScreenInfo,maximumLuminance_cdm2,StimulusList_main,logIncrementMagnitude); % calculate the next stimulus intensity required in the staircase based on logarithmic step sizes
                end
            end
            
            
            % Calculate staircase threshold:
            if StimulusList_main(stimulusIndex).nPresentations > 10 && StimulusList_main(stimulusIndex).StaircaseObject.nReversals >= nReversalsRequired % if the staircase has had at least 10 tries of attempting reversal and the patient hasn't seen the stimulus 10 times then visual field threshold must be the highest it can be at this location
                StimulusList_main(stimulusIndex).Presentations(StimulusList_main(stimulusIndex).nPresentations).stimulusIntensity = 1; % visual field threshold must be the highest it can be at this location
            end
            if StimulusList_main(stimulusIndex).StaircaseObject.nReversals >= nReversalsRequired
                StimulusList_main(stimulusIndex).presentAsStaircase = false; % we no longer need to present this one as a staircase
                indexToBeRemoved = presentationListForThisWave == stimulusIndex; % remove stimulus from overall
                presentationListForThisWave = presentationListForThisWave(presentationListForThisWave ~= presentationListForThisWave(indexToBeRemoved));
            end
        else % QUEST presentation
            if strcmp(waveName,'first')
                while repeatTrial
                    [escapePressed,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,StimulusList_main,pausePressed,~,repeatTrial] = presentation('first',StimulusList_main,nPresentationsThisWave,window,ScreenInfo,stimulusDuration_ms,CentralFixationTarget,backgroundLuminance_AU,eye,gazeContingencyType,FixationReminderAnnulus,[],tracker,driftCorrectionOffset_deg,manualFixationOffset_deg,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,stimulusIndex,startTimestamp,falsePositiveCatchTime_sec,dynamicIntervalRange_min_max_sec,pausePressed,additionToInterstimulusInterval_sec,startingIntensityAboveNormativeData_logarithmic,falsePOSfalseNEG_logIncrement,maximumLuminance_cdm2); % first presentations actually use all the principles of a QUEST presentation, except they are much brighter
                    if repeatTrial % if we have to repeat the trial...
                        stimulusIndex = randsample(presentationListForThisWave,1); % draw another stimulus index to use before we loop back up
                    else % otherwise, remove from the presentationList, as we only show each stimulus once in the first wave
                        indexToBeRemoved = presentationListForThisWave == stimulusIndex;
                        presentationListForThisWave = presentationListForThisWave(presentationListForThisWave ~= presentationListForThisWave(indexToBeRemoved));
                    end
                end
            else
                while repeatTrial
                    [escapePressed,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,StimulusList_main,pausePressed,~,repeatTrial] = presentation('quest',StimulusList_main,nPresentationsThisWave,window,ScreenInfo,stimulusDuration_ms,CentralFixationTarget,backgroundLuminance_AU,eye,gazeContingencyType,FixationReminderAnnulus,[],tracker,driftCorrectionOffset_deg,manualFixationOffset_deg,reactionTimeRecord_sec,nFalsePositiveResponses,nFalseNegativeResponses,stimulusIndex,startTimestamp,falsePositiveCatchTime_sec,dynamicIntervalRange_min_max_sec,pausePressed,additionToInterstimulusInterval_sec,startingIntensityAboveNormativeData_logarithmic,falsePOSfalseNEG_logIncrement,maximumLuminance_cdm2);
                    if repeatTrial % if we have to repeat the trial...
                        stimulusIndex = randsample(presentationListForThisWave,1); % draw another stimulus index to use before we loop back up
                    end
                end
            end
            % Calculate next stimulus intensity:
            if ~isnan(StimulusList_main(stimulusIndex).Presentations(end).seen) % seen should only be a NaN if something went wrong
                StimulusList_main(stimulusIndex).QuestObject = QuestUpdate(StimulusList_main(stimulusIndex).QuestObject,StimulusList_main(stimulusIndex).Presentations(end).stimulusIntensity,StimulusList_main(stimulusIndex).Presentations(end).seen); % update QUEST object to contain response
                if StimulusList_main(stimulusIndex).nPresentations >= 6
                    intervalSize = QuestQuantile(StimulusList_main(stimulusIndex).QuestObject,0.95) - QuestQuantile(StimulusList_main(stimulusIndex).QuestObject,0.5); % this is the size of the confidence interval required before QUEST is allowed to terminate
                    if intervalSize <= questTerminationMaximumIntervalSize
                        if StimulusList_main(stimulusIndex).nUp >= 1 && StimulusList_main(stimulusIndex).nDown >= 1 % if the staircase (or QUEST) procedure has both ascended and descended at some point...
                            indexToBeRemoved = presentationListForThisWave == stimulusIndex;
                            presentationListForThisWave = presentationListForThisWave(presentationListForThisWave ~= presentationListForThisWave(indexToBeRemoved)); % remove this presentation from the list so that it isn't shown again
                        else
                            %StaircaseParameters(stimulusIndex).useStaircasesIfQuestFails = true;
                            StimulusList_main(stimulusIndex).presentAsStaircase = true; % if QUEST has calculated threshold but there has been no reversal in stimulus intensity then the threshold calcualated by QUEST should not be trusted and the stimulus presentation should be switched to a staircase.
                        end
                    end
                end
            end
        end
        if strcmp(StimulusList_main(stimulusIndex).Presentations(end).trialType,'quest') && StimulusList_main(stimulusIndex).nPresentations > 1 % for a QUEST presentation, we need to check whether we have been ascending or descending, because this forms part of the termination criteria
            if StimulusList_main(stimulusIndex).Presentations(end).stimulusIntensity > StimulusList_main(stimulusIndex).Presentations(end - 1).stimulusIntensity % if this stimulusIntensity is brighter than the last one we did at the same position...
                StimulusList_main(stimulusIndex).nUp = StimulusList_main(stimulusIndex).nUp + 1;
            elseif StimulusList_main(stimulusIndex).Presentations(end).stimulusIntensity < StimulusList_main(stimulusIndex).Presentations(end - 1).stimulusIntensity % if this stimulusIntensity is dimmer than the last one we did at the same position...
                StimulusList_main(stimulusIndex).nDown = StimulusList_main(stimulusIndex).nDown + 1;
            end
        end
    else
        thisWaveComplete = true; % when all stimulus positions have an interval of less than half of the specified chi-square criterion, terminate whole program (see Watson and Pelli, 1983)
    end
    if escapePressed
        return
    end
end



function newStimulusIntensity_au = calculatenextstaircaseintensity(previousStimulusIntensity_au,ScreenInfo,maximumLuminance_cdm2,StimulusList_main,logIncrementMagnitude)

previousStimulusIntensity_cdm2 = convert_au2cdm2(previousStimulusIntensity_au,ScreenInfo); % convert into cdm2
if StimulusList_main(stimulusIndex).StaircaseObject.direction == -1
    newStimulusIntensity_dB = log10(maximumLuminance_cdm2/previousStimulusIntensity_cdm2)*10 + logIncrementMagnitude; % this converts the previous stimulus intensity into the equivalent dB and adds the log increment magnitude to it
    newStimulusIntensity_cdm2 = 10.^(log10(maximumLuminance_cdm2) - newStimulusIntensity_dB/10); % to convert the new stimulus intensity to cdm2
    %newStimulusIntensity_cdm2 = previousStimulusIntensity_cdm2 + logIncrementMagnitude  * log10(maximumLuminance_cdm2);
else
    newStimulusIntensity_dB = log10(maximumLuminance_cdm2/previousStimulusIntensity_cdm2)*10 - logIncrementMagnitude; % this converts the previous stimulus intensity into the equivalent dB and adds the log increment magnitude to it
    newStimulusIntensity_cdm2 = 10.^(log10(maximumLuminance_cdm2) - newStimulusIntensity_dB/10); % to convert the new stimulus intensity to cdm2
    %newStimulusIntensity_cdm2 = previousStimulusIntensity_cdm2 - logIncrementMagnitude  * log10(maximumLuminance_cdm2);
end
newStimulusIntensity_au = convert_cdm22au(newStimulusIntensity_cdm2,ScreenInfo); % convert back to au
